# 说明
一个模板中可以包含一个或多个测试算例，主要用于读者自行检查编写的程序是否符合实验题目的要求，同时，教师还可以通过附加算例检查学生是否作弊。每个测试算例中需要包含数据源文件和结果文件，数据源文件可以是重定向的标准输入文件，也可以是通过命令行提供的文本文件和二进制文件，结果文件可以是重定向的标准输出文件，也可以是通过命令行提供的文本文件和二进制文件。根据数据源文件和结果文件的不同，可以分为以下几种情况：
## 标准输入和标准输出
数据源文件是通过输入重定向提供的，文件名：input1.txt。结果文件是通过重定向输出提供的，文件名：output1.txt。数据源文件和结果文件可以是以下组合：  
（1）数据源文件：input1.txt，结果文件：output1.txt。  
（2）数据源文件：无，结果文件：output1.txt。

`注意`:如果包含多个测试算例以此类推，测试算例2使用的是 input2.txt 和 output2.txt。  
## 读文件和写文件
数据源文件是通过命令行参数提供的，如果读取的是二进制文件，文件名：readfile1.dat,如果读取的是文本文件，文件名：readfile1.txt。结果文件也是通过命令行参数提供的，如果写入的是二进制文件，文件名：writefile1.dat,如果写入的是文本文件，文件名：writefile1.txt。数据源文件和结果文件可以是以下组合：  
（1）数据源文件：readfile1.txt，结果文件：writefile1.dat。  
（2）数据源文件：readfile1.txt，结果文件：writefile1.txt。  
（3）数据源文件：readfile1.dat，结果文件：writefile1.dat。    
（4）数据源文件：readfile1.dat，结果文件：writefile1.txt。

## 读文件和标准输出
数据源文件是通过命令行参数提供的，如果读取的是二进制文件，文件名：readfile1.dat,如果读取的是文本文件，文件名：readfile1.txt。结果文件是通过重定向输出提供的，文件名：output1.txt。
数据源文件和结果文件可以是以下组合：  
（1）数据源文件：readfile1.txt，结果文件：output1.txt。  
（2）数据源文件：readfile1.dat，结果文件：output1.txt。

## 标准输入和写文件
数据源文件是通过输入重定向提供的，文件名：input1.txt。结果文件也是通过命令行参数提供的，如果写入的是二进制文件，文件名：writefile1.dat,如果写入的是文本文件，文件名：writefile1.txt。数据源文件和结果文件可以是以下组合：  
（1）数据源文件：input1.txt，结果文件：writefile1.dat。  
（2）数据源文件：input1.txt，结果文件：writefile1.txt。 

## 读取指定文件和输出
如果在编写程序直接将文件名称写入到程序中，该文件如果是二进制文件，文件名为：specifyfile.dat,如果是文本文件，文件名：specifyfile.txt。结果文件是通过命令行参数提供的，如果写入的是二进制文件，文件名：writefile1.dat,如果写入的是文本文件，文件名：writefile1.txt; 结果文件是通过重定向输出提供的，文件名：output1.txt。数据源文件和结果文件可以是以下组合：  
（1）数据源文件：无，结果文件：writefile1.dat。    
（2）数据源文件：无，结果文件：writefile1.txt。   
（3）数据源文件：无，结果文件：output1.txt。    


# 使用方法
为学生布置任务前，要先使用此模板创建一个任务模板。方法如下：
1. 在自己的群组中新建一个项目，新建项目时，不要创建空白项目，选择右侧的“导入项目”，然后选择“Repo by URL”作为导入源。将本项目的Git URL复制到“Git仓库URL”中。其他的控件按照自己的要求填入后，点击最下方的“创建项目”按钮，完成新建项目。这个新建的项目会用于给学生创建任务。
2. 打开 VSCode，将新建的项目克隆到本地。
3. 编辑数据源文件和结果文件。写入实验要求的输入输出内容。
4. 编辑 readme.md 文件的内容，通常在此文件中写明实验的要求，让学生依据要求完成实验。推荐将输入输出样例写入 readme.md 文件中方便学生查看。
5. 如果有必要，也可以修改 main.c 文件，提供一个合适的代码基。或者在项目中加入其它的头文件和C文件。
6. 推送项目到 Git 远程库。
7. 如果有答案源代码的话，最好能做一个测试，确保学生能够顺利完成实验。方法是：新建一个课程，使用刚刚制作的模板项目新建一个任务，将学生添加到课程中，发布课程和任务后，使用学生账号领取任务，打开VSCode,然后在克隆任务的项目时根据提示输入学生账号，将源代码答案填入main.c文件后提交作业。如果线上的流水线成功，并得到了100分。说明模板制作成功了。否则需要按照上面的步骤继续修改模板。
